<id>
din1031:ThankOMatic
</id>

<version>
1.2.3
</version>

<edit file>
$boarddir/index.php
</edit file>

<search for>
		'theme' => array('Themes.php', 'ThemesMain'),
</search for>

<add before>
		'thankyou' => array('ThankYouPost.php', 'ThankYou'),
		'thankyoupostlock' => array('ThankYouPost.php', 'ThankYouPostLock'),
		'thankyoupostlist' => array('ThankYouPost.php', 'ThankYouPostListShow'),
		'thankyoupostdelete' => array('ThankYouPost.php', 'ThankYouPostDelete'),
		'thankyoupostdm' => array('ThankYouPost.php', 'ThankYouPostDeletePost'),
		'thankyoupostcloseall' => array('ThankYouPost.php', 'ThankYouPostCloseAll'),
		'thankyoupostunlockall' => array('ThankYouPost.php', 'ThankYouPostUnlockAllPosts'),
		'thankyoupostrecountall' => array('ThankYouPost.php', 'ThankYouPostRecountAll'),
		'thankyoupostrepairtable' => array('ThankYouPost.php', 'ThankYouPostRepairTable'),
</add before>

<edit file>
$boarddir/SSI.php
</edit file>

<search for>
// Check the passed ID_MEMBER/password.  If $is_username is true, treats $id as a username.
</search for>

<replace>
// Shows the top Thank You Resive.
function ssi_thankYouPostTopResived($topMembers = 5, $output_method = 'echo')
{
	global $db_prefix, $txt, $scripturl, $modSettings;

	// Find the latest poster.
	$request = db_query("
		SELECT ID_MEMBER, realName, thank_you_post_became, thank_you_post_made
		FROM {$db_prefix}members
		ORDER BY thank_you_post_became DESC
		LIMIT $topMembers", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
		$return[] = array(
			'id' => $row['ID_MEMBER'],
			'name' => $row['realName'],
			'href' => $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>',
			'thank_you_post_became' => $row['thank_you_post_became'],
			'thank_you_post_made' => $row['thank_you_post_made']
		);
	mysql_free_result($request);
	
	if ($output_method != 'echo')
		return $return;
		
	if(empty($return))
		return;

	echo '
		<table class="ssi_table">
			<tr>
				<th align="left"></th>
				<th align="left">', $txt['thank_you_post_became_display'], '</th>
				<th align="left">', $txt['thank_you_post_made_display'], '</th>
			</tr>';
	foreach ($return as $temp)
		echo '
			<tr>
				<td align="left">
					', $temp['link'], '
				</td>
				<td align="right">', $temp['thank_you_post_became'], '</td>
				<td align="right">', $temp['thank_you_post_made'], '</td>
			</tr>';
	echo '
		</table>';
}

// Shows the top Thank You Given.
function ssi_thankYouPostTopGiven($topMembers = 5, $output_method = 'echo')
{
	global $db_prefix, $txt, $scripturl, $modSettings;

	// Find the latest poster.
	$request = db_query("
		SELECT ID_MEMBER, realName, thank_you_post_became, thank_you_post_made
		FROM {$db_prefix}members
		ORDER BY thank_you_post_made DESC
		LIMIT $topMembers", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
		$return[] = array(
			'id' => $row['ID_MEMBER'],
			'name' => $row['realName'],
			'href' => $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>',
			'thank_you_post_became' => $row['thank_you_post_became'],
			'thank_you_post_made' => $row['thank_you_post_made']
		);
	mysql_free_result($request);
	
	if ($output_method != 'echo')
		return $return;
		
	if(empty($return))
		return;

	echo '
		<table class="ssi_table">
			<tr>
				<th align="left"></th>
				<th align="left">', $txt['thank_you_post_made_display'], '</th>
				<th align="left">', $txt['thank_you_post_became_display'], '</th>
			</tr>';
	foreach ($return as $temp)
		echo '
			<tr>
				<td align="left">
					', $temp['link'], '
				</td>
				<td align="right">', $temp['thank_you_post_made'], '</td>
				<td align="right">', $temp['thank_you_post_became'], '</td>
			</tr>';
	echo '
		</table>';
}

// Check the passed ID_MEMBER/password.  If $is_username is true, treats $id as a username.
</replace>

<edit file>
$boarddir/ssi_examples.php
</edit file>

<search for>
			<?php ssi_recentEvents(); flush(); ?>

		<hr />
</search for>

<replace>
			<?php ssi_recentEvents(); flush(); ?>

		<hr />

			<h3>Top Thank You Received Function: &lt;?php ssi_thankYouPostTopResived(); ?&gt;</h3>
			<?php ssi_thankYouPostTopResived(); flush(); ?>

		<hr />

			<h3>Top Thank You Given Function: &lt;?php ssi_thankYouPostTopGiven(); ?&gt;</h3>
			<?php ssi_thankYouPostTopGiven(); flush(); ?>

		<hr />
</replace>

<edit file>
$sourcedir/Display.php
</edit file>

<search for>
			t.ID_MEMBER_STARTED, t.ID_FIRST_MSG, t.ID_LAST_MSG,
</search for>

<replace>
			t.thank_you_post_locked,
			t.ID_MEMBER_STARTED, t.ID_FIRST_MSG, t.ID_LAST_MSG,
</replace>

<search for>
	$context['is_hot'] = $topicinfo['numReplies'] >= $modSettings['hotTopicPosts'];
</search for>

<replace>
	$context['is_hot'] = $topicinfo['numReplies'] >= $modSettings['hotTopicPosts'];
	
	//Some Thanky You things ;)
	$context['is_thank_you_post_locked'] = $topicinfo['thank_you_post_locked'];
	$context['thank_you_lock_allowed'] = !empty($board_info['thank_you_post_enable']) && !$user_info['is_guest'] && (allowedTo('thank_you_post_lock_all_any') || (allowedTo('thank_you_post_lock_all_own') && $ID_MEMBER == $topicinfo['ID_MEMBER_STARTED']));
	$context['thank_you_post_enable'] = $board_info['thank_you_post_enable'];
	$context['thank_you_post_unlock_all'] = false;
</replace>

<search for>
		FROM {$db_prefix}messages
		WHERE ID_TOPIC = $topic
		ORDER BY ID_MSG " . ($ascending ? '' : 'DESC') . ($modSettings['defaultMaxMessages'] == -1 ? '' : "
</search for>

<add before>
		".($board_info['thank_you_post_enable'] ? ", thank_you_post" : "")."
</add before>

<search for>
	$messages = array();
	$posters = array();
</search for>

<add after>
	$thank_you_posts = array();
</add after>

<search for>
		if (!empty($row['ID_MEMBER']))
			$posters[] = $row['ID_MEMBER'];
		$messages[] = $row['ID_MSG'];
</search for>

<add after>
		if (!empty($row['thank_you_post']))
			$thank_you_posts[] = $row['ID_MSG'];
</add after>

<search for>
			// This is better than sorting it with the query...
			ksort($temp);

			foreach ($temp as $row)
				$attachments[$row['ID_MSG']][] = $row;
		}
</search for>

<add after>

		$context['thank_you_post']['postet_thanks'] = array();
		$context['thank_you_post']['topic'] = null;
				
		//The user will a thank you list?
		if($board_info['thank_you_post_enable'] && (allowedTo('thank_you_post_show') || allowedTo('thank_you_post_post'))) {
			//Possible strange settings fix...
			if(!empty($modSettings['thankYouPostDisableUnhide']) && empty($modSettings['thankYouPostThxUnhideAll']) && empty($modSettings['thankYouPostUnhidePost']))
				$modSettings['thankYouPostDisableUnhide'] = 0;

			if(!empty($modSettings['thankYouPostPreview']) && !empty($thank_you_posts) && allowedTo('thank_you_post_show')) {
				//Should i gernerate a list? Need a extra query :)
				include($sourcedir.'/ThankYouPost.php');
				ThankYouPostList($thank_you_posts, true);
			}
			//Okay no preview so in need to load the data extra for this :)
			if(!empty($thank_you_posts) && !empty($ID_MEMBER) && allowedTo('thank_you_post_post')) {
				//Search for one made or the made one in the thread ;)
				$thx = db_query("
					SELECT ID_THX_POST, ID_MSG
					FROM {$db_prefix}thank_you_post
					WHERE ID_TOPIC = $topic 
						".(!empty($modSettings['thankYouPostOnePerPost']) ? "AND ID_MSG IN (".implode(', ', $thank_you_posts).")" : "")."
						AND ID_MEMBER = $ID_MEMBER
						".(empty($modSettings['thankYouPostOnePerPost']) ? "LIMIT 1" : ""), __FILE__, __LINE__);
					
				while($row = mysql_fetch_assoc($thx)) {
					$context['thank_you_post']['postet_thanks'][$row['ID_MSG']] = $row['ID_THX_POST'];
				}
				mysql_free_result($thx);

				$context['thank_you_post']['topic'] = $topic;
				
				//Okay Hide Tag Special Handling in Thank You Mod
				if(!empty($modSettings['thankYouPostDisableUnhide']))
					$context['user_post_avaible'] = 0;
				//Unhide all after one post?
				if(!empty($modSettings['thankYouPostThxUnhideAll']) && !empty($context['thank_you_post']['postet_thanks']))
					$context['user_post_avaible'] = 1;
			}
			elseif(!empty($modSettings['thankYouPostDisableUnhide'])) 
				$context['user_post_avaible'] = 0;
		}
</add after>

<search for>
				ID_MSG_MODIFIED < $topicinfo[new_from] AS isRead
			FROM {$db_prefix}messages
</search for>

<add before>
				".($board_info['thank_you_post_enable'] && allowedTo('thank_you_post_show') ? "thank_you_post, thank_you_post_counter," : "")."
</add before>

<search for>
	// Do the censor thang.
	censorText($message['body']);
	censorText($message['subject']);
</search for>

<add after>

	//Second Option for unhide content, for special hide tag
	$disable_unhideafter = false;
	if((!empty($modSettings['thankYouPostUnhidePost']) && empty($context['user_post_avaible']) && isset($context['thank_you_post']['postet_thanks'][$message['ID_MSG']]) && empty($modSettings['thankYouPostThxUnhideAll'])) || (!empty($modSettings['thankYouPostDisableUnhide']) && $ID_MEMBER == $message['ID_MEMBER'])) {
		$disable_unhideafter = true;
		$context['user_post_avaible'] = 1;
	}
</add after>

<search for>
		'can_see_ip' => allowedTo('moderate_forum') || ($message['ID_MEMBER'] == $ID_MEMBER && !empty($ID_MEMBER)),
</search for>

<add after>
		'thank_you_post' => array(
			'post' => $context['thank_you_post_enable'] && empty($context['is_thank_you_post_locked']) && allowedTo('thank_you_post_post') && $ID_MEMBER != $message['ID_MEMBER'] && !isset($context['thank_you_post']['postet_thanks'][$message['ID_MSG']]) && !(empty($modSettings['thankYouPostOnePerPost']) && !empty($context['thank_you_post']['postet_thanks'])),
			'lock' => $context['thank_you_post_enable'] && empty($context['is_thank_you_post_locked']) && (allowedTo('thank_you_post_lock_any') || (allowedTo('thank_you_post_lock_own') && $ID_MEMBER == $message['ID_MEMBER'])),
			'delete' => $context['thank_you_post_enable'] && allowedTo('thank_you_post_delete_any') || (allowedTo('thank_you_post_delete_own') && $ID_MEMBER == $message['ID_MEMBER']),
			'counter' => $context['thank_you_post_enable'] && !empty($message['thank_you_post_counter']) ? $message['thank_you_post_counter'] : '0',
			'locked' => $context['thank_you_post_enable'] && !empty($message['thank_you_post']) && $message['thank_you_post'] > 1,
			'isThankYouPost' => $context['thank_you_post_enable'] && !empty($message['thank_you_post']) && $message['thank_you_post'] >= 1,
			'href' => $context['thank_you_post_enable'] ? $scripturl . '?action=thankyoupostlist;topic=' . $topic . '.0;msg='.$message['ID_MSG'] : '',
		),
</add after>

<search for>
	if (empty($options['view_newest_first']))
		$counter++;
	else
		$counter--;
</search for>

<add before>
	//This Options apear only if realy a thank you is in there, and one is locked *g*
	if($context['thank_you_post_enable'] && allowedTo('thank_you_post_unlock_all') && !empty($message['thank_you_post']) && $message['thank_you_post'] > 1)
		$context['thank_you_post_unlock_all'] = true;

	//Second Option for unhide content, for special hide tag
	if($disable_unhideafter) 
		$context['user_post_avaible'] = 0;
	
</add before>

<edit file>
$sourcedir/Load.php
</edit file>

<search for>
				b.ID_THEME, b.override_theme, b.permission_mode, b.countPosts
</search for>

<replace>
				b.ID_THEME, b.override_theme, b.permission_mode, b.countPosts
				, thank_you_post_enable
</replace>

<search for>
				'posts_count' => empty($row['countPosts']),
</search for>

<replace>
				'posts_count' => empty($row['countPosts']),
				'thank_you_post_enable' => empty($row['thank_you_post_enable']),
</replace>

<search for>
			mem.birthdate, mem.memberIP, mem.memberIP2, mem.ICQ, mem.AIM, mem.YIM, mem.MSN, mem.posts, mem.lastLogin,
			mem.karmaGood, mem.ID_POST_GROUP, mem.karmaBad, mem.lngfile, mem.ID_GROUP, mem.timeOffset, mem.showOnline,
</search for>

<add after>
			mem.thank_you_post_made, mem.thank_you_post_became,
</add after>

<search for>
			mem.timeFormat, mem.secretQuestion, mem.is_activated, mem.additionalGroups, mem.smileySet, mem.showOnline,
			mem.totalTimeLoggedIn, mem.ID_POST_GROUP, mem.notifyAnnouncements, mem.notifyOnce, mem.notifySendBody,
</search for>

<add after>
			mem.thank_you_post_made, mem.thank_you_post_became,
</add after>

<search for>
			mem.ID_MEMBER, mem.memberName, mem.realName, mem.emailAddress, mem.hideEmail, mem.dateRegistered,
</search for>

<add after>
			mem.thank_you_post_made, mem.thank_you_post_became,
</add after>

<search for>
		'local_time' => timeformat(time() + ($profile['timeOffset'] - $user_info['time_offset']) * 3600, false),
</search for>

<add after>
		'thank_you_post' => array(
			'made' => &$profile['thank_you_post_made'],
			'became' => &$profile['thank_you_post_became'],
		),
</add after>

<edit file>
$sourcedir/ManageBoards.php
</edit file>

<search for>
			'permission_mode' => 'normal',
</search for>

<add after>
			'thank_you_post_enable' => 0,
</add after>

<search for>
		$boardOptions['posts_count'] = isset($_POST['count']);
</search for>

<add after>
		$boardOptions['thank_you_post_enable'] = isset($_POST['thank_you_post_enable']);
</add after>

<edit file>
$sourcedir/ManagePermissions.php
</edit file>

<search for>
		'profile_view_own',
		'profile_identity_own',
</search for>

<add after>
		'thank_you_post_show',
</add after>

<search for>
		'report_any',
		'send_topic',
</search for>

<add after>
		'thank_you_post_post',
		'thank_you_post_lock_own',
		'thank_you_post_lock_any',
		'thank_you_post_delete_own',		
		'thank_you_post_delete_any',
		'thank_you_post_delete_mem_own',		
		'thank_you_post_delete_mem_any',
		'thank_you_post_lock_all_own',
		'thank_you_post_lock_all_any',
</add after>

<search for>
			'notification' => array(
				'mark_any_notify' => false,
				'mark_notify' => false,
			),
</search for>

<add after>
			'thank_you_post' => array(
				'thank_you_post_post' => false,
				'thank_you_post_show' => false,
				'thank_you_post_delete' => true,
				'thank_you_post_lock' => true,
				'thank_you_post_lock_all' => true,
				'thank_you_post_unlock_all' => false,
				'thank_you_post_delete_mem' => true,		
			),
</add after>

<search for>
		'manage_bans',
		'send_mail',
</search for>

<add after>
		'thank_you_post_post',
		'thank_you_post_lock',
		'thank_you_post_delete',
		'thank_you_post_delete_mem',
		'thank_you_post_lock_all',
		'thank_you_post_unlock_all',
</add after>

<edit file>
$sourcedir/ModSettings.php
</edit file>

<search for>
		'layout' => 'ModifyLayoutSettings',
</search for>

<add after>
		'thankyoupost' => 'ModifyThankYouPostSettings',
</add after>

<search for>
			'layout' => array(
				'title' => $txt['mods_cat_layout'],
				'href' => $scripturl . '?action=featuresettings;sa=layout;sesc=' . $context['session_id'],
			),
</search for>

<add after>
			'thankyoupost' => array(
				'title' => $txt['thankyouposttitle'],
				'href' => $scripturl . '?action=featuresettings;sa=thankyoupost;sesc=' . $context['session_id'],
			),
</add after>

<search for>
	$context['post_url'] = $scripturl . '?action=featuresettings2;save;sa=karma';
	$context['settings_title'] = $txt['smf293'];

	prepareDBSettingContext($config_vars);
}
</search for>

<add after>

function ModifyThankYouPostSettings()
{
	global $txt, $scripturl, $context, $settings, $sc;

	$config_vars = array(
			// Thank You Post, some Stanadard settings :)
			array('check', 'thankYouPostOnePerPost'),
			array('check', 'thankYouPostColors'),
			array('check', 'thankYouPostDisplayPage'),
		'',
			// Okay only the preview settings :)
			array('check', 'thankYouPostPreview'),
			array('int', 'thankYouPostPreviewHM'),
			array('select', 'thankYouPostPreviewOrder', explode('|', $txt['thankYouPostPreviewOrderSelect'])),
		'',
			// Okay only the Full List settings :)
			array('select', 'thankYouPostFullOrder', explode('|', $txt['thankYouPostFullOrderSelect'])),
		'',
			//Hmm it'S compatible to my Hide Mod... and have two options xD
			array('check', 'thankYouPostUnhidePost'),
			array('check', 'thankYouPostThxUnhideAll'),
			array('check', 'thankYouPostDisableUnhide'),
	);

	// Saving?
	if (isset($_GET['save']))
	{
		saveDBSettings($config_vars);
		redirectexit('action=featuresettings;sa=thankyoupost');
	}

	$context['post_url'] = $scripturl . '?action=featuresettings2;save;sa=thankyoupost';
	$context['settings_title'] = $txt['thankyouposttitle'];

	prepareDBSettingContext($config_vars);
}
</add after>

<edit file>
$sourcedir/MoveTopic.php
</edit file>

<search for>
	db_query("
		UPDATE {$db_prefix}calendar
		SET ID_BOARD = $toBoard
		WHERE ID_TOPIC $condition
		LIMIT $numTopics", __FILE__, __LINE__);
</search for>

<add after>

	// Move the thank you's to the the new Board :)
	db_query("
		UPDATE {$db_prefix}thank_you_post
		SET ID_BOARD = $toBoard
		WHERE ID_TOPIC $condition", __FILE__, __LINE__);
</add after>

<edit file>
$sourcedir/Profile.php
</edit file>

<search for>
	void showPosts(int ID_MEMBER)
</search for>

<add before>
	void showThankYouPosts(int ID_MEMBER)
		- Generate a list of Post with thank you given to this user
		- Posts are in Chronological Order
		- Load Thank You lists, but only if the user allowed to view it
</add before>

<search for>
		'showPosts' => array(array('profile_view_any', 'profile_view_own'), array('profile_view_any')),
</search for>

<replace>
		'showPosts' => array(array('profile_view_any', 'profile_view_own'), array('profile_view_any')),
		'showThankYouPosts' => array(array('profile_view_any', 'profile_view_own'), array('profile_view_any')),
</replace>

<search for>
			$context['profile_areas']['info']['areas']['showPosts']	= '<a href="' . $scripturl . '?action=profile;u=' . $memID . ';sa=showPosts">' . $txt['showPosts'] . '</a>';
</search for>

<replace>
			$context['profile_areas']['info']['areas']['showPosts']	= '<a href="' . $scripturl . '?action=profile;u=' . $memID . ';sa=showPosts">' . $txt['showPosts'] . '</a>';
			$context['profile_areas']['info']['areas']['showThankYouPosts']	= '<a href="' . $scripturl . '?action=profile;u=' . $memID . ';sa=showThankYouPosts">' . $txt['thankyoutitle'] . '</a>';
</replace>

<search for>
		'website' => array(
			'title' => !isset($user_profile[$memID]['websiteTitle']) ? '' : $user_profile[$memID]['websiteTitle'],
			'url' => !isset($user_profile[$memID]['websiteUrl']) ? '' : $user_profile[$memID]['websiteUrl'],
		),
</search for>

<add after>
		'thank_you_post' => array(
			'made' => !isset($user_profile[$memID]['thank_you_post_made']) ? '0' : $user_profile[$memID]['thank_you_post_made'],
			'became' => !isset($user_profile[$memID]['thank_you_post_became']) ? '0' : $user_profile[$memID]['thank_you_post_became'],
		),
</add after>

<search for>
		// Change the number of posts.
		if (isset($_POST['posts']) && allowedTo('moderate_forum'))
			$profile_vars['posts'] = $_POST['posts'] != '' ? (int) strtr($_POST['posts'], array(',' => '', '.' => '', ' ' => '')) : '\'\'';
</search for>

<add after>

		// Change the Thank You Post settings :), something only the admin can do ;) or people who allowed to moderate the forum ;)
		if (isset($_POST['thank_you_post_made']) && allowedTo('moderate_forum'))
			$profile_vars['thank_you_post_made'] = $_POST['thank_you_post_made'] != '' ? (int) strtr($_POST['thank_you_post_made'], array(',' => '', '.' => '', ' ' => '')) : '\'\'';
		if (isset($_POST['thank_you_post_became']) && allowedTo('moderate_forum'))
			$profile_vars['thank_you_post_became'] = $_POST['thank_you_post_became'] != '' ? (int) strtr($_POST['thank_you_post_became'], array(',' => '', '.' => '', ' ' => '')) : '\'\'';
</add after>

<search for>
// Show all the users buddies, as well as a add/delete interface.
function editBuddies($memID)
{
</search for>

<replace>
// Show all thank you posts by the current user
function showThankYouPosts($memID)
{
	global $txt, $user_info, $scripturl, $modSettings, $db_prefix;
	global $context, $user_profile, $ID_MEMBER, $sourcedir;

	// If just deleting a message, do it and then redirect back.
	if (isset($_GET['delete']))
	{
		checkSession('get');

		// We can be lazy, since removeMessage() will check the permissions for us.
		require_once($sourcedir . '/RemoveTopic.php');
		removeMessage((int) $_GET['delete']);

		// Back to... where we are now ;).
		redirectexit('action=profile;u=' . $memID . ';sa=showPosts;start=' . $_GET['start']);
	}

	// Is the load average too high to allow searching just now?
	if (!empty($context['load_average']) && !empty($modSettings['loadavg_show_posts']) && $context['load_average'] >= $modSettings['loadavg_show_posts'])
		fatal_lang_error('loadavg_show_posts_disabled', false);

	// Default to 10.
	if (empty($_REQUEST['viewscount']) || !is_numeric($_REQUEST['viewscount']))
		$_REQUEST['viewscount'] = '10';

	$request = db_query("
		SELECT COUNT(*)
		FROM ({$db_prefix}messages AS m, {$db_prefix}boards AS b)
		WHERE m.ID_MEMBER = $memID
			AND b.ID_BOARD = m.ID_BOARD
			AND m.thank_you_post = 1
			AND $user_info[query_see_board]", __FILE__, __LINE__);
	list ($msgCount) = mysql_fetch_row($request);
	mysql_free_result($request);

	$request = db_query("
		SELECT MIN(ID_MSG), MAX(ID_MSG)
		FROM {$db_prefix}messages AS m
		WHERE m.ID_MEMBER = $memID
		AND m.thank_you_post = 1", __FILE__, __LINE__);
	list ($min_msg_member, $max_msg_member) = mysql_fetch_row($request);
	mysql_free_result($request);

	$reverse = false;
	$range_limit = '';
	$maxIndex = (int) $modSettings['defaultMaxMessages'];

	// Make sure the starting place makes sense and construct our friend the page index.
	$context['start'] = (int) $_REQUEST['start'];
	$context['page_index'] = constructPageIndex($scripturl . '?action=profile;u=' . $memID . ';sa=showThankYouPosts', $context['start'], $msgCount, $maxIndex);
	$context['current_page'] = $context['start'] / $maxIndex;
	$context['current_member'] = $memID;

	// Reverse the query if we're past 50% of the pages for better performance.
	$start = $context['start'];
	$reverse = $_REQUEST['start'] > $msgCount / 2;
	if ($reverse)
	{
		$maxIndex = $msgCount < $context['start'] + $modSettings['defaultMaxMessages'] + 1 && $msgCount > $context['start'] ? $msgCount - $context['start'] : (int) $modSettings['defaultMaxMessages'];
		$start = $msgCount < $context['start'] + $modSettings['defaultMaxMessages'] + 1 || $msgCount < $context['start'] + $modSettings['defaultMaxMessages'] ? 0 : $msgCount - $context['start'] - $modSettings['defaultMaxMessages'];
	}

	// Guess the range of messages to be shown.
	if ($msgCount > 1000)
	{
		$margin = floor(($max_msg_member - $min_msg_member) * (($start + $modSettings['defaultMaxMessages']) / $msgCount) + .1 * ($max_msg_member - $min_msg_member));
		$range_limit = $reverse ? 'ID_MSG < ' . ($min_msg_member + $margin) : 'ID_MSG > ' . ($max_msg_member - $margin);
	}

	$context['page_title'] = $txt['thankyoutitle'] . ': ' . $user_profile[$memID]['realName'];

	// Find this user's posts.  The left join on categories somehow makes this faster, weird as it looks.
	$looped = false;
	while (true)
	{
		$request = db_query("
			SELECT
				b.ID_BOARD, b.name AS bname, c.ID_CAT, c.name AS cname, m.ID_TOPIC, m.ID_MSG,
				t.ID_MEMBER_STARTED, t.ID_FIRST_MSG, t.ID_LAST_MSG, m.body, m.smileysEnabled,
				m.subject, m.posterTime
				, m.thank_you_post_counter, m.thank_you_post
			FROM ({$db_prefix}messages AS m, {$db_prefix}topics AS t, {$db_prefix}boards AS b)
				LEFT JOIN {$db_prefix}categories AS c ON (c.ID_CAT = b.ID_CAT)
			WHERE m.ID_MEMBER = $memID
				AND m.ID_TOPIC = t.ID_TOPIC
				AND m.thank_you_post = 1
				AND t.ID_BOARD = b.ID_BOARD" . (empty($range_limit) ? '' : "
				AND $range_limit") . "
				AND $user_info[query_see_board]
			ORDER BY m.ID_MSG " . ($reverse ? 'ASC' : 'DESC') . "
			LIMIT $start, $maxIndex", __FILE__, __LINE__);

		// Make sure we quit this loop.
		if (mysql_num_rows($request) === $maxIndex || $looped)
			break;
		$looped = true;
		$range_limit = '';
	}

	// Start counting at the number of the first message displayed.
	$counter = $reverse ? $context['start'] + $maxIndex + 1 : $context['start'];
	$context['posts'] = array();
	$board_ids = array('own' => array(), 'any' => array());
	$thank_you_posts = array();
	while ($row = mysql_fetch_assoc($request))
	{
		// Censor....
		censorText($row['body']);
		censorText($row['subject']);

		// Do the code.
		$row['body'] = parse_bbc($row['body'], $row['smileysEnabled'], $row['ID_MSG']);

		// And the array...
		$context['posts'][$counter += $reverse ? -1 : 1] = array(
			'body' => $row['body'],
			'counter' => $counter,
			'category' => array(
				'name' => $row['cname'],
				'id' => $row['ID_CAT']
			),
			'board' => array(
				'name' => $row['bname'],
				'id' => $row['ID_BOARD']
			),
			'topic' => $row['ID_TOPIC'],
			'subject' => $row['subject'],
			'start' => 'msg' . $row['ID_MSG'],
			'time' => timeformat($row['posterTime']),
			'timestamp' => forum_time(true, $row['posterTime']),
			'id' => $row['ID_MSG'],
			'can_reply' => false,
			'can_mark_notify' => false,
			'can_delete' => false,
			'delete_possible' => ($row['ID_FIRST_MSG'] != $row['ID_MSG'] || $row['ID_LAST_MSG'] == $row['ID_MSG']) && (empty($modSettings['edit_disable_time']) || $row['posterTime'] + $modSettings['edit_disable_time'] * 60 >= time()),
			'thank_you_post' => array(
				'locked' => !empty($row['thank_you_post']) && $row['thank_you_post'] > 1,
				'counter' => !empty($row['thank_you_post_counter']) ? $row['thank_you_post_counter'] : '0',
				'isThankYouPost' => !empty($row['thank_you_post']) && $row['thank_you_post'] >= 1,
				'href' => $scripturl . '?action=thankyoupostlist;topic=' . $row['ID_TOPIC'] . '.0;msg='.$row['ID_MSG'],
			),
		);

		$thank_you_posts[] = $row['ID_MSG'];

		if ($ID_MEMBER == $row['ID_MEMBER_STARTED'])
			$board_ids['own'][$row['ID_BOARD']][] = $counter;
		$board_ids['any'][$row['ID_BOARD']][] = $counter;
	}
	mysql_free_result($request);

	// All posts were retrieved in reverse order, get them right again.
	if ($reverse)
		$context['posts'] = array_reverse($context['posts'], true);

	// These are all the permissions that are different from board to board..
	$permissions = array(
		'own' => array(
			'post_reply_own' => 'can_reply',
			'delete_own' => 'can_delete',
		),
		'any' => array(
			'post_reply_any' => 'can_reply',
			'mark_any_notify' => 'can_mark_notify',
			'delete_any' => 'can_delete',
		)
	);

	// For every permission in the own/any lists...
	foreach ($permissions as $type => $list)
	{
		foreach ($list as $permission => $allowed)
		{
			// Get the boards they can do this on...
			$boards = boardsAllowedTo($permission);

			// Hmm, they can do it on all boards, can they?
			if (!empty($boards) && $boards[0] == 0)
				$boards = array_keys($board_ids[$type]);

			// Now go through each board they can do the permission on.
			foreach ($boards as $board_id)
			{
				// There aren't any posts displayed from this board.
				if (!isset($board_ids[$type][$board_id]))
					continue;

				// Set the permission to true ;).
				foreach ($board_ids[$type][$board_id] as $counter)
					$context['posts'][$counter][$allowed] = true;
			}
		}
	}

	// Clean up after posts that cannot be deleted.
	foreach ($context['posts'] as $counter => $dummy)
		$context['posts'][$counter]['can_delete'] &= $context['posts'][$counter]['delete_possible'];

	//Load A Preview?
	if(!empty($modSettings['thankYouPostPreview']) && !empty($thank_you_posts) && allowedTo('thank_you_post_show')) {
		//Should i gernerate a list? Need a extra query :)
		require_once($sourcedir.'/ThankYouPost.php');
		ThankYouPostList($thank_you_posts, true);
	}
}

// Show all the users buddies, as well as a add/delete interface.
function editBuddies($memID)
{
</replace>

<edit file>
$sourcedir/RemoveTopic.php
</edit file>

<search for>
				UPDATE {$db_prefix}messages
				SET icon = 'recycled'
</search for>

<add after>
				, thank_you_post = IF(thank_you_post = 1, 2, thank_you_post)
</add after>

<search for>
			// Mark recycled topic as read.
</search for>

<add before>
			//Okay i changed above... it lock the thank you ;P so it's not possible to made more thanks in the junkyard
</add before>

<search for>
			// Make sure this message isn't getting deleted later on.
</search for>

<add before>
			// Okay the thank you must be moved to the recycler too ;)
			db_query("
				UPDATE {$db_prefix}thank_you_post
				SET 
					ID_TOPIC = $topicID,
					ID_BOARD = $modSettings[recycle_board]
				WHERE ID_MSG = $message", __FILE__, __LINE__);
			
</add before>

<search for>
	// Delete anything related to the topic.
	db_query("
		DELETE FROM {$db_prefix}messages
		WHERE ID_TOPIC $condition", __FILE__, __LINE__);
</search for>

<add before>
	//Delete the Thank You Posts from this topics, before the message removed... i need the starter of the messages <<
	require_once($sourcedir.'/ThankYouPost.php');
	ThankYouPostRemoveTopics($topics);

</add before>

<edit file>
$sourcedir/Security.php
</edit file>

<search for>
			'move_any',
			'send_topic',
</search for>

<add after>
			'thank_you_post_post', 'thank_you_post_lock_own', 'thank_you_post_lock_any', 
			'thank_you_post_delete_own', 'thank_you_post_delete_any',
			'thank_you_post_delete_mem_own', 'thank_you_post_delete_mem_any',
			'thank_you_post_lock_all_own', 'thank_you_post_lock_all_any',
			'thank_you_post_unlock_all',
</add after>

<edit file>
$sourcedir/SplitTopics.php
</edit file>

<search for>
	// Cache the new topics subject... we can do it now as all the subjects are the same!
	updateStats('subject', $split2_ID_TOPIC, $new_subject);
</search for>

<add before>
	//Move the Thank You Post over to the other topic... bh this is work :(
	db_query("
		UPDATE {$db_prefix}thank_you_post
		SET
			ID_TOPIC = $split2_ID_TOPIC
		WHERE ID_MSG IN ($postList)", __FILE__, __LINE__);
	
</add before>

<search for>
	// Merge log topic entries.
</search for>

<add before>
	// Change the Thank You post to the new board and topic ;D
	db_query("
		UPDATE {$db_prefix}thank_you_post
		SET
			ID_TOPIC = $ID_TOPIC,
			ID_BOARD = $target_board
		WHERE ID_TOPIC IN (" . implode(', ', $deleted_topics) . ")", __FILE__, __LINE__);

</add before>

<edit file>
$sourcedir/Subs-Boards.php
</edit file>

<search for>
	// This setting is a little twisted in the database...
	if (isset($boardOptions['posts_count']))
		$boardUpdates[] = 'countPosts = ' . ($boardOptions['posts_count'] ? '0' : '1');
</search for>

<add after>

	// So enable or disable the Thank You Post in a board :D...
	if (isset($boardOptions['thank_you_post_enable']))
		$boardUpdates[] = 'thank_you_post_enable = ' . ($boardOptions['thank_you_post_enable'] ? '0' : '1');
</add after>

<search for>
		'posts_count' => true,
</search for>

<add after>
		'thank_you_post_enable' => false,
</add after>

<search for>
	// Delete any message icons that only appear on these boards.
	db_query("
		DELETE FROM {$db_prefix}message_icons
		WHERE ID_BOARD IN (" . implode(', ', $boards_to_remove) . ')', __FILE__, __LINE__);
</search for>

<add after>

	// Delete any Thank You Posts that only appear on these boards.
	db_query("
		DELETE FROM {$db_prefix}thank_you_post
		WHERE ID_BOARD IN (" . implode(', ', $boards_to_remove) . ')', __FILE__, __LINE__);
</add after>

<search for>
			b.boardOrder, b.countPosts, b.memberGroups, b.ID_THEME, b.override_theme,
</search for>

<add after>
			thank_you_post_enable,
</add after>

<search for>
				'count_posts' => empty($row['countPosts']),
</search for>

<add after>
				'thank_you_post_enable' => empty($row['thank_you_post_enable']),
</add after>

<edit file>
$themedir/Admin.template.php
</edit file>

<search for>
					<a href="' . $scripturl . '?action=convertentities">' . $txt['entity_convert_title'] . '</a><br />' : '', '
</search for>

<add after>
					<a href="', $scripturl, '?action=thankyoupostrecountall">', $txt['maintain_thxpostrecount'], '</a><br />
					<a href="', $scripturl, '?action=thankyoupostrepairtable">', $txt['maintain_thxpostrepair'], '</a><br />
</add after>

<edit file>
$themedir/Display.template.php
</edit file>

<search for>
	else
		unset($normal_buttons['custom']);
</search for>

<add after>

	//Special Lock for the Thank You :)
	if($context['thank_you_lock_allowed'])
		if(empty($context['is_thank_you_post_locked']))
			$normal_buttons['thankyoupostlock'] = array('text' => 'thank_you_post_lock_all_b', 'image' => 'thank_you_lock1.gif', 'lang' => true, 'url' => $scripturl . '?action=thankyoupostcloseall;topic=' . $context['current_topic']);
		else
			$normal_buttons['thankyoupostlock'] = array('text' => 'thank_you_post_open_all_b', 'image' => 'thank_you_lock2.gif', 'lang' => true, 'url' => $scripturl . '?action=thankyoupostcloseall;topic=' . $context['current_topic']);
	//A Fix for later, if some Translations are not Updated
	if(empty($txt['thank_you_link_aftercounters']))
		$txt['thank_you_link_aftercounters'] = $txt['thank_you_link_aftercounter'];
</add after>

<search for>
	$split_button = create_button('split.gif', 'smf251', 'smf251', 'align="middle"');
</search for>

<add after>
	$thankyoupostpost_button = create_button('thank_you_b.gif', 'thank_you_post_post_b', 'thank_you_post_post_b', 'align="middle"');
	$thankyoupostlock_button = create_button('thank_you_b.gif', 'thank_you_post_lock_b', 'thank_you_post_lock_b', 'align="middle"');
	$thankyoupostopen_button = create_button('thank_you_b.gif', 'thank_you_post_open_b', 'thank_you_post_open_b', 'align="middle"');
	$thankyoupostdelete_button = create_button('thank_you_b.gif', 'thank_you_post_delete_b', 'thank_you_post_delete_b', 'align="middle"');
</add after>

<search for>
			// Show avatars, images, etc.?
</search for>

<add before>
			if(!empty($modSettings['thankYouPostDisplayPage'])) {
			echo '
								', $txt['thank_you_post_thx_display'], '<br />
								-', $txt['thank_you_post_made_display'], ': ', $message['member']['thank_you_post']['made'], '<br />
								-', $txt['thank_you_post_became_display'], ': ', $message['member']['thank_you_post']['became'], '<br />
								<br />';
			}

</add before>

<search for>
		// What about splitting it off the rest of the topic?
		if ($context['can_split'])
			echo '
					<a href="', $scripturl, '?action=splittopics;topic=', $context['current_topic'], '.0;at=', $message['id'], '">', $split_button, '</a>';
</search for>

<add after>
	
		// Can do some Thank You Post things :)
		if ($message['thank_you_post']['post'] && !$message['thank_you_post']['locked'])
			echo '
					<a href="', $scripturl, '?action=thankyou;topic=', $context['current_topic'], '.0;msg=', $message['id'], '">', $thankyoupostpost_button, '</a>';
		
		if ($message['thank_you_post']['lock'] && $message['thank_you_post']['isThankYouPost']) 
			echo '
					<a href="', $scripturl, '?action=thankyoupostlock;topic=', $context['current_topic'], '.0;msg=', $message['id'], '">', $message['thank_you_post']['locked'] ? $thankyoupostopen_button : $thankyoupostlock_button, '</a>';	

		if ($message['thank_you_post']['delete'] && $message['thank_you_post']['isThankYouPost']) 
			echo '
					<a href="', $scripturl, '?action=thankyoupostdelete;topic=', $context['current_topic'], '.0;msg=', $message['id'], ';sesc=', $context['session_id'], '" onclick="return confirm(\'', $txt['remove_thank_you_post'], '?\');">', $thankyoupostdelete_button, '</a>';	
</add after>

<search for>
		echo '
								</td>
							</tr><tr>
								<td valign="bottom" class="smalltext" id="modified_', $message['id'], '">';
</search for>

<add before>
		//Show the Thank You list or the link or.... nothing? XD
		if ($message['thank_you_post']['isThankYouPost']) {
			echo '
							</tr><tr class="ThankOMatic">
								<td colspan="2" class="smalltext" width="100%">
									<hr width="100%" size="1" class="hrcolor" />';
			if(!empty($context['thank_you_post'][$message['id']])) {
				echo '
									<p>'.$txt['followgiveathank'].'</p><p>';

				foreach($context['thank_you_post'][$message['id']]['fulllist'] as $thx)
					echo $thx['link'].(!empty($thx['deletelink']) ? $thx['deletelink'] : '').($thx['last'] ? '' : ', ');

				echo '
									</p>';
			}
			
			//Counter and Link to the direkt or complete list :)
			echo '
									<a href="'.$message['thank_you_post']['href'].'">
										'.$txt['thank_you_link_beforecounter'].' '.$message['thank_you_post']['counter'].' '.($message['thank_you_post']['counter'] == 1 ? $txt['thank_you_link_member'] : $txt['thank_you_link_members']).' '.($message['thank_you_post']['counter'] == 1 ? $txt['thank_you_link_aftercounter'] : $txt['thank_you_link_aftercounters']).'
									</a>';
			
			if($message['thank_you_post']['locked'])
				echo '<br />
									<span class="smalltext"><i>'.$txt['thank_you_is_locked'].'</i></span>';
		}

</add before>

<search for>
	if ($context['can_remove_post'] && !empty($options['display_quick_mod']) && $options['display_quick_mod'] == 1)
		$mod_buttons[] = array('text' => 'quickmod_delete_selected', 'image' => 'delete_selected.gif', 'lang' => true, 'custom' => 'onclick="return confirm(\'' . $txt['quickmod_confirm'] . '\');" id="quickmodSubmit"', 'url' => 'javascript:document.quickModForm.submit();');
</search for>

<add after>
	if($context['thank_you_post_unlock_all'])
		$mod_buttons[] = array('text' => 'thank_you_post_unlock_all', 'image' => 'thankyoulock2.gif', 'lang' => true, 'url' => $scripturl . '?action=thankyoupostunlockall;topic=' . $context['current_topic'] . '.0');
</add after>

<edit file>
$themedir/ManageBoards.template.php
</edit file>

<search for>
	// Finish off the table.
	echo '
</search for>

<add before>
	// Add the Thank You Post Informations... Enable or Disable this option for a board :)
	echo '	
							<tr>
								<td>
									<b>', $txt['mboards_thank_you_post_enable'], '</b><br />
									', $txt['mboards_thank_you_post_enable_desc'], '<br /><br />
								</td>
								<td valign="top" align="right">
									<input type="checkbox" name="thank_you_post_enable" ', $context['board']['thank_you_post_enable'] ? ' checked="checked"' : '', ' class="check" />
								</td>
							</tr>';
</add before>

<edit file>
$themedir/Profile.template.php
</edit file>

<search for>
	if (!empty($modSettings['userLanguage']))
		echo '
					<td><b>', $txt['smf225'], ':</b></td>
					<td>', $context['member']['language'], '</td>
				</tr><tr>';
</search for>

<add after>

	//Thank You Infomations :)
	echo '
					<td colspan="2"><hr size="1" width="100%" class="hrcolor" /></td>
				</tr><tr>
					<td colspan="2" align="center"><u><b>'.$txt['thankyoutitle'].'</b></u></td>
				</tr><tr>
					<td><b>', $txt['thankyoupostmade'], ':</b></td>
					<td>', $context['member']['thank_you_post']['made'], '</td>
				</tr><tr>
					<td><b>', $txt['thankyoupostbecame'], ':</b></td>
					<td>', $context['member']['thank_you_post']['became'], '</td>
				</tr><tr>';
</add after>

<search for>
									', $modSettings['karmaApplaudLabel'], ' <input type="text" name="karmaGood" size="4" value="', $context['member']['karma']['good'], '" onchange="setInnerHTML(document.getElementById(\'karmaTotal\'), this.value - this.form.karmaBad.value);" style="margin-right: 2ex;" /> ', $modSettings['karmaSmiteLabel'], ' <input type="text" name="karmaBad" size="4" value="', $context['member']['karma']['bad'], '" onchange="this.form.karmaGood.onchange();" /><br />
									(', $txt[94], ': <span id="karmaTotal">', ($context['member']['karma']['good'] - $context['member']['karma']['bad']), '</span>)
								</td>
							</tr>';
	}
</search for>

<replace>
									', $modSettings['karmaApplaudLabel'], ' <input type="text" name="karmaGood" size="4" value="', $context['member']['karma']['good'], '" onchange="setInnerHTML(document.getElementById(\'karmaTotal\'), this.value - this.form.karmaBad.value);" style="margin-right: 2ex;" /> ', $modSettings['karmaSmiteLabel'], ' <input type="text" name="karmaBad" size="4" value="', $context['member']['karma']['bad'], '" onchange="this.form.karmaGood.onchange();" /><br />
									(', $txt[94], ': <span id="karmaTotal">', ($context['member']['karma']['good'] - $context['member']['karma']['bad']), '</span>)
								</td>
							</tr>';
	}

	// Admins are allowed to change the Thank-O-Matic Stats :D
	if ($context['user']['is_admin'])
	{
		echo '
							<tr>
								<td colspan="2"><hr width="100%" size="1" class="hrcolor" /></td>
							</tr><tr>
							<tr>
								<td><b>', $txt['thankyoutitle'], ' ', $txt['thankyoupostmade'], ': </b></td>
								<td><input type="text" name="thank_you_post_made" size="4" value="', $context['member']['thank_you_post']['made'], '" /></td>
							</tr>
							<tr>
								<td><b>', $txt['thankyoutitle'], ' ', $txt['thankyoupostbecame'], ': </b></td>
								<td><input type="text" name="thank_you_post_became" size="4" value="', $context['member']['thank_you_post']['became'], '" /></td>
							</tr>';
	}
</replace>

<search for>
// Template for showing all the buddies of the current user.
function template_editBuddies()
{
</search for>

<replace>
// Template for showing all the Thank You Posts of the user, in chronological order.
function template_showThankYouPosts()
{
	global $context, $settings, $options, $scripturl, $modSettings, $txt;

	echo '
		<table border="0" width="85%" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
			<tr class="titlebg">
				<td colspan="3" height="26">
					&nbsp;<img src="', $settings['images_url'], '/icons/profile_sm.gif" alt="" align="top" />&nbsp;', $txt['thankyoutitle'], '
				</td>
			</tr>';

	// Only show posts if they have made some!
	if (!empty($context['posts']))
	{
		// Page numbers.
		echo '
			<tr class="catbg3">
				<td colspan="3">
					', $txt[139], ': ', $context['page_index'], '
				</td>
			</tr>
		</table>';

		// Button shortcuts
		$quote_button = create_button('quote.gif', 145, 'smf240', 'align="middle"');
		$reply_button = create_button('reply_sm.gif', 146, 146, 'align="middle"');
		$remove_button = create_button('delete.gif', 121, 31, 'align="middle"');
		$notify_button = create_button('notify_sm.gif', 131, 125, 'align="middle"');

		// For every post to be displayed, give it its own subtable, and show the important details of the post.
		foreach ($context['posts'] as $post)
		{
			echo '
		<table border="0" width="85%" cellspacing="1" cellpadding="0" class="bordercolor" align="center">
			<tr>
				<td width="100%">
					<table border="0" width="100%" cellspacing="0" cellpadding="4" class="bordercolor" align="center">
						<tr class="titlebg2">
							<td style="padding: 0 1ex;">
								', $post['counter'], '
							</td>
							<td width="75%" class="middletext">
								&nbsp;<a href="', $scripturl, '#', $post['category']['id'], '">', $post['category']['name'], '</a> / <a href="', $scripturl, '?board=', $post['board']['id'], '.0">', $post['board']['name'], '</a> / <a href="', $scripturl, '?topic=', $post['topic'], '.', $post['start'], '#msg', $post['id'], '">', $post['subject'], '</a>
							</td>
							<td class="middletext" align="right" style="padding: 0 1ex; white-space: nowrap;">
								', $txt[30], ': ', $post['time'], '
							</td>
						</tr>
						<tr>
							<td width="100%" height="80" colspan="3" valign="top" class="windowbg2">
								<div class="post">', $post['body'], '</div>
							</td>';

			//Show the Thank You list or the link or.... nothing? XD
			if ($post['thank_you_post']['isThankYouPost']) {
				echo '
							</tr><tr class="ThankOMatic">
								<td colspan="3" class="windowbg2" width="100%">
									<hr width="100%" size="1" class="hrcolor" />
									<span class="smalltext">';
				if(!empty($context['thank_you_post'][$post['id']])) {
					echo '
									<p>'.$txt['followgiveathank'].'</p><p>';

					foreach($context['thank_you_post'][$post['id']]['fulllist'] as $thx)
						echo $thx['link'].(!empty($thx['deletelink']) ? $thx['deletelink'] : '').($thx['last'] ? '' : ', ');

					echo '
									</p>';
				}
			
				//Counter and Link to the direkt or complete list :)
				echo '
									<a href="'.$post['thank_you_post']['href'].'">
										'.$txt['thank_you_link_beforecounter'].' '.$post['thank_you_post']['counter'].' '.($post['thank_you_post']['counter'] == 1 ? $txt['thank_you_link_member'] : $txt['thank_you_link_members']).' '.$txt['thank_you_link_aftercounter'].'
									</a>';
			
				if($post['thank_you_post']['locked'])
					echo '<br />
									<span class="smalltext"><i>'.$txt['thank_you_is_locked'].'</i></span>';
				echo '
							</span></td>';

			}

			echo '
						</tr>
						<tr>
							<td colspan="3" class="windowbg2" align="', !$context['right_to_left'] ? 'right' : 'left', '"><span class="middletext">';

			if ($post['can_delete'])
				echo '
					<a href="', $scripturl, '?action=profile;u=', $context['current_member'], ';sa=showPosts;start=', $context['start'], ';delete=', $post['id'], ';sesc=', $context['session_id'], '" onclick="return confirm(\'', $txt[154], '?\');">', $remove_button, '</a>';
			if ($post['can_delete'] && ($post['can_mark_notify'] || $post['can_reply']))
				echo '
								', $context['menu_separator'];
			if ($post['can_reply'])
				echo '
					<a href="', $scripturl, '?action=post;topic=', $post['topic'], '.', $post['start'], '">', $reply_button, '</a>', $context['menu_separator'], '
					<a href="', $scripturl, '?action=post;topic=', $post['topic'], '.', $post['start'], ';quote=', $post['id'], ';sesc=', $context['session_id'], '">', $quote_button, '</a>';
			if ($post['can_reply'] && $post['can_mark_notify'])
				echo '
								', $context['menu_separator'];
			if ($post['can_mark_notify'])
				echo '
					<a href="' . $scripturl . '?action=notify;topic=' . $post['topic'] . '.' . $post['start'] . '">' . $notify_button . '</a>';

			echo '
							</span></td>
						</tr>
					</table>
				</td>
			</tr>
		</table>';
		}

		// Show more page numbers.
		echo '
		<table border="0" width="85%" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
			<tr>
				<td colspan="3" class="catbg3">
					', $txt[139], ': ', $context['page_index'], '
				</td>
			</tr>
		</table>';
	}
	// No posts? Just end the table with a informative message.
	else
		echo '
			<tr class="windowbg2">
				<td>
					', $txt[170], '
				</td>
			</tr>
		</table>';
}

// Template for showing all the buddies of the current user.
function template_editBuddies()
{
</replace>
