<id>
din1031:ThankOMatic
</id>

<version>
1.0.0
</version>

<edit file>
$boarddir/SSI.php
</edit file>

<search for>
// Check the passed ID_MEMBER/password.  If $is_username is true, treats $id as a username.
</search for>

<replace>
// Shows the top Thank You Resive.
function ssi_thankYouPostTopResived($topMembers = 5, $output_method = 'echo')
{
	global $db_prefix, $txt, $scripturl, $modSettings;

	// Find the latest poster.
	$request = db_query("
		SELECT ID_MEMBER, realName, thank_you_post_became, thank_you_post_made
		FROM {$db_prefix}members
		ORDER BY thank_you_post_became DESC
		LIMIT $topMembers", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
		$return[] = array(
			'id' => $row['ID_MEMBER'],
			'name' => $row['realName'],
			'href' => $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>',
			'thank_you_post_became' => $row['thank_you_post_became'],
			'thank_you_post_made' => $row['thank_you_post_made']
		);
	mysql_free_result($request);
	
	if ($output_method != 'echo')
		return $return;
		
	if(empty($return))
		return;

	echo '
		<table class="ssi_table">
			<tr>
				<th align="left"></th>
				<th align="left">', $txt['thank_you_post_became_display'], '</th>
				<th align="left">', $txt['thank_you_post_made_display'], '</th>
			</tr>';
	foreach ($return as $temp)
		echo '
			<tr>
				<td align="left">
					', $temp['link'], '
				</td>
				<td align="right">', $temp['thank_you_post_became'], '</td>
				<td align="right">', $temp['thank_you_post_made'], '</td>
			</tr>';
	echo '
		</table>';
}

// Shows the top Thank You Given.
function ssi_thankYouPostTopGiven($topMembers = 5, $output_method = 'echo')
{
	global $db_prefix, $txt, $scripturl, $modSettings;

	// Find the latest poster.
	$request = db_query("
		SELECT ID_MEMBER, realName, thank_you_post_became, thank_you_post_made
		FROM {$db_prefix}members
		ORDER BY thank_you_post_made DESC
		LIMIT $topMembers", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
		$return[] = array(
			'id' => $row['ID_MEMBER'],
			'name' => $row['realName'],
			'href' => $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>',
			'thank_you_post_became' => $row['thank_you_post_became'],
			'thank_you_post_made' => $row['thank_you_post_made']
		);
	mysql_free_result($request);
	
	if ($output_method != 'echo')
		return $return;
		
	if(empty($return))
		return;

	echo '
		<table class="ssi_table">
			<tr>
				<th align="left"></th>
				<th align="left">', $txt['thank_you_post_made_display'], '</th>
				<th align="left">', $txt['thank_you_post_became_display'], '</th>
			</tr>';
	foreach ($return as $temp)
		echo '
			<tr>
				<td align="left">
					', $temp['link'], '
				</td>
				<td align="right">', $temp['thank_you_post_made'], '</td>
				<td align="right">', $temp['thank_you_post_became'], '</td>
			</tr>';
	echo '
		</table>';
}

// Check the passed ID_MEMBER/password.  If $is_username is true, treats $id as a username.
</replace>

<edit file>
$boarddir/ssi_examples.php
</edit file>

<search for>
			<?php ssi_recentEvents(); flush(); ?>

		<hr />
</search for>

<replace>
			<?php ssi_recentEvents(); flush(); ?>

		<hr />

			<h3>Top Thank You Received Function: &lt;?php ssi_thankYouPostTopResived(); ?&gt;</h3>
			<?php ssi_thankYouPostTopResived(); flush(); ?>

		<hr />

			<h3>Top Thank You Given Function: &lt;?php ssi_thankYouPostTopGiven(); ?&gt;</h3>
			<?php ssi_thankYouPostTopGiven(); flush(); ?>

		<hr />
</replace>

<edit file>
$sourcedir/ModSettings.php
</edit file>

<search for>
			array('check', 'thankYouPostOnePerPost'),
			array('check', 'thankYouPostColors'),
</search for>

<replace>
			array('check', 'thankYouPostOnePerPost'),
			array('check', 'thankYouPostColors'),
			array('check', 'thankYouPostDisplayPage'),
</replace>

<edit file>
$themedir/Display.template.php
</edit file>

<search for>
			// Show avatars, images, etc.?
</search for>

<add before>
			if(!empty($modSettings['thankYouPostDisplayPage'])) {
			echo '
								', $txt['thank_you_post_thx_display'], '<br />
								-', $txt['thank_you_post_made_display'], ': ', $message['member']['thank_you_post']['made'], '<br />
								-', $txt['thank_you_post_became_display'], ': ', $message['member']['thank_you_post']['became'], '<br />
								<br />';
			}

</add before>
